package org.siqisource.agave.orm;

import java.util.ArrayList;
import java.util.List;

import org.siqisource.agave.orm.util.NameConverter;

public class Condition {

	/** expressions */
	private List<SqlCompareExpression> expressions = null;

	/** orderBy */
	private String orderBy = null;

	/** groupBy */
	private String groupBy = null;

	public Condition() {

	}
	
	public void addExpression(SqlCompareExpression expression) {
		if (expressions == null) {
			expressions = new ArrayList<SqlCompareExpression>();
		}
		expressions.add(expression);
	}

	public String getComboedExpressions() {
		StringBuffer sql = new StringBuffer();
		if (expressions != null) {
			if (expressions.size() > 0) {
				for (int i = 0, iSize = expressions.size(); i < iSize; i++) {
					SqlCompareExpression expression = expressions.get(i);
					sql.append(expression.getExpression(i));
				}
			}
		}

		return sql.toString();
	}
	
	public Condition copy() {
		Condition conditionList = new Condition();
		conditionList.orderBy = this.orderBy;
		conditionList.groupBy = this.groupBy;
		conditionList.expressions = new ArrayList<SqlCompareExpression>();
		for (SqlCompareExpression expression : this.expressions) {
			conditionList.expressions.add(expression);// fleet copy
		}
		return conditionList;
	}

	public void orderBy(String propertiesName, String direction) {
		StringBuffer sbOrderBy = new StringBuffer(" ORDER BY ");
		String fieldsName = NameConverter.getColumns(propertiesName);
		sbOrderBy.append(fieldsName);
		this.orderBy = sbOrderBy.append(" ").append(direction).toString();
	}

	public void groupBy(String propertiesName) {
		StringBuffer sbGroupBy = new StringBuffer(" GROUP BY ");
		String fieldsName = NameConverter.getColumns(propertiesName);
		sbGroupBy.append(fieldsName);
		this.groupBy = sbGroupBy.toString();
	}

	public String getGroupBy() {
		return groupBy;
	}

	public String getOrderBy() {
		return orderBy;
	}
	

	public List<SqlCompareExpression> getExpressions() {
		return expressions;
	}

}
