package org.siqisource.agave.orm;

import java.util.HashMap;
import java.util.Map;

import org.siqisource.agave.orm.util.NameConverter;

public class PartitiveFields extends HashMap<String, Object> {

	/**
	 * serialVersionUID
	 */
	private static final long serialVersionUID = 3865131202288816404L;


	/**
	 * prepare Fields to insert
	 * 
	 * @param fields
	 * @return
	 */
	public void prepareInsertSql() {
		if (this.get("_insertFields")==null) {

			StringBuffer sbInsertFields = new StringBuffer();
			StringBuffer sbInsertValues = new StringBuffer();
			boolean firstFiled = true;
			for (Map.Entry<String, Object> entry : this.entrySet()) {
				String key = entry.getKey();
				if (!firstFiled) {
					sbInsertFields.append(" , ");
					sbInsertValues.append(" , ");
				}
				sbInsertFields.append(NameConverter.propertyToColumn(key));
				
				sbInsertValues.append("#{fields[");
				sbInsertValues.append(key);
				sbInsertValues.append("]}");
				
				firstFiled = false;
			}
			this.put("_insertFields",sbInsertFields.toString());
			this.put("_insertValues",sbInsertValues.toString());
		}
	}

	/**
	 * prepare sql to update
	 * 
	 * @return
	 */
	public void prepareUpdateSql() {
		if (this.get("_updateSql")==null) {
			StringBuffer sbUpdateSql = new StringBuffer();
			boolean firstFiled = true;
			for (Map.Entry<String, Object> entry : this.entrySet()) {
				String key = entry.getKey();
				if (!firstFiled) {
					sbUpdateSql.append(" , ");
				}
				sbUpdateSql.append(NameConverter.propertyToColumn(key));
				sbUpdateSql.append(" = #{fields[");
				sbUpdateSql.append(key);
				sbUpdateSql.append("]}");
				firstFiled = false;
			}
			this.put("_updateSql", sbUpdateSql.toString());
		}
	}
}
