package org.siqisource.agave.orm.expression;

import java.util.Arrays;
import java.util.List;

public class ListValueExpression extends SqlCompareExpressionImpl {


	public ListValueExpression(String prefix, String column,
			String compareSymbol,List<Object> value, String suffix) {
		super(prefix, column, compareSymbol, suffix);
		this.value = value;
	}
	
	public ListValueExpression(String prefix, String column,
			String compareSymbol,String value, String suffix) {
		super(prefix, column, compareSymbol, suffix);
		this.value = Arrays.asList((Object[])value.split(","));
	}

	private List<Object> value;
	

	
	public List<Object> getValue() {
		return value;
	}

	public void setValue(List<Object> value) {
		this.value = value;
	}

	public String getExpression(int indexInCondition) {
		StringBuffer expression = new StringBuffer();
		expression.append(this.prefix);
		expression.append(this.column);
		expression.append(this.compareSymbol);
		expression.append("<foreach collection='");
		expression.append("condition.expressions[");
		expression.append(indexInCondition);
		expression.append("].value");
		expression.append("' index='index' item='item' open='(' separator=',' close=')'> ");
		expression.append("#{item}");
		expression.append(" </foreach> ");
		expression.append(this.suffix);
		return expression.toString();
	}

}
